3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
49 my $ok = join("|", qw(
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59 print join("\n", @vars);
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
67 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
68 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
69 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
72 # Protect ourselves from common misconfiguration to export
73 # CDPATH into the environment
78 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
80 echo "* warning: Some tests will not work if GIT_TRACE" \
81 "is set as to trace on STDERR ! *"
82 echo "* warning: Please set GIT_TRACE to something" \
83 "other than 1, 2 or true ! *"
89 # A regexp to match 5 and 40 hexdigits
90 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
91 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
94 _z40=0000000000000000000000000000000000000000
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
116 while test "$#" -ne 0
119 -d|--d|--de|--deb|--debu|--debug)
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
134 with_dashes=t; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
140 shift ;; # was handled already
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
149 if test -n "$color"; then
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
169 test -z "$1" && test -n "$quiet" && return
176 say_color error "error: $*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
190 echo "$test_description"
195 if test "$verbose" = "t"
199 exec 4>/dev/null 3>/dev/null
208 test_external_has_tap=0
212 if test -n "$GIT_EXIT_OK"
216 echo >&5 "FATAL: Unexpected exit with code $code"
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
236 EDITOR='"$FAKE_EDITOR"'
240 test_decode_color () {
243 if (n == 0) return "RESET";
244 if (n == 1) return "BOLD";
245 if (n == 30) return "BLACK";
246 if (n == 31) return "RED";
247 if (n == 32) return "GREEN";
248 if (n == 33) return "YELLOW";
249 if (n == 34) return "BLUE";
250 if (n == 35) return "MAGENTA";
251 if (n == 36) return "CYAN";
252 if (n == 37) return "WHITE";
253 if (n == 40) return "BLACK";
254 if (n == 41) return "BRED";
255 if (n == 42) return "BGREEN";
256 if (n == 43) return "BYELLOW";
257 if (n == 44) return "BBLUE";
258 if (n == 45) return "BMAGENTA";
259 if (n == 46) return "BCYAN";
260 if (n == 47) return "BWHITE";
263 while (match($0, /\033\[[0-9;]*m/) != 0) {
264 printf "%s<", substr($0, 1, RSTART-1);
265 codes = substr($0, RSTART+2, RLENGTH-3);
266 if (length(codes) == 0)
269 n = split(codes, ary, ";");
271 for (i = 1; i <= n; i++) {
272 printf "%s%s", sep, name(ary[i]);
277 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
301 sed -e 's/$/Q/' | tr Q '\015'
305 tr '\015' Q | sed -e 's/Q$//'
308 # In some bourne shell implementations, the "unset" builtin returns
309 # nonzero status when a variable to be unset was not set in the first
312 # Use sane_unset when that should not be considered an error.
320 if test -z "${test_tick+set}"
324 test_tick=$(($test_tick + 60))
326 GIT_COMMITTER_DATE="$test_tick -0700"
327 GIT_AUTHOR_DATE="$test_tick -0700"
328 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
331 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
333 # This will commit a file with the given contents and the given commit
334 # message. It will also add a tag with <message> as name.
336 # Both <file> and <contents> default to <message>.
340 echo "${3-$1}" > "$file" &&
343 git commit -m "$1" &&
347 # Call test_merge with the arguments "<message> <commit>", where <commit>
348 # can be a tag pointing to the commit-to-merge.
352 git merge -m "$1" "$2" &&
356 # This function helps systems where core.filemode=false is set.
357 # Use it instead of plain 'chmod +x' to set or unset the executable bit
358 # of a file in the working directory and add it to the index.
362 git update-index --add "--chmod=$@"
365 # Unset a configuration variable, but don't fail if it doesn't exist.
367 git config --unset-all "$@"
369 case "$config_status" in
370 5) # ok, nothing to unset
374 return $config_status
377 # Set git config, automatically unsetting it after the test is over.
379 test_when_finished "test_unconfig '$1'" &&
383 # Use test_set_prereq to tell that a particular prerequisite is available.
384 # The prerequisite can later be checked for in two ways:
386 # - Explicitly using test_have_prereq.
388 # - Implicitly by specifying the prerequisite tag in the calls to
389 # test_expect_{success,failure,code}.
391 # The single parameter is the prerequisite tag (a simple word, in all
392 # capital letters by convention).
395 satisfied="$satisfied$1 "
399 test_have_prereq () {
400 # prerequisites can be concatenated with ','
412 total_prereq=$(($total_prereq + 1))
415 ok_prereq=$(($ok_prereq + 1))
418 # Keep a list of missing prerequisites
419 if test -z "$missing_prereq"
421 missing_prereq=$prerequisite
423 missing_prereq="$prerequisite,$missing_prereq"
428 test $total_prereq = $ok_prereq
431 test_declared_prereq () {
432 case ",$test_prereq," in
440 # You are not expected to call test_ok_ and test_failure_ directly, use
441 # the text_expect_* functions instead.
444 test_success=$(($test_success + 1))
445 say_color "" "ok $test_count - $@"
449 test_failure=$(($test_failure + 1))
450 say_color error "not ok - $test_count $1"
452 echo "$@" | sed -e 's/^/# /'
453 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
456 test_known_broken_ok_ () {
457 test_fixed=$(($test_fixed+1))
458 say_color "" "ok $test_count - $@ # TODO known breakage"
461 test_known_broken_failure_ () {
462 test_broken=$(($test_broken+1))
463 say_color skip "not ok $test_count - $@ # TODO known breakage"
467 test "$debug" = "" || eval "$1"
471 # This is a separate function because some tests use
472 # "return" to end a test_expect_success block early.
482 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
484 test_eval_ "$test_cleanup"
486 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
493 test_count=$(($test_count+1))
495 for skp in $GIT_SKIP_TESTS
497 case $this_test.$test_count in
503 if test -z "$to_skip" && test -n "$test_prereq" &&
504 ! test_have_prereq "$test_prereq"
511 if test "$missing_prereq" != "$test_prereq"
513 of_prereq=" of $test_prereq"
516 say_color skip >&3 "skipping test: $@"
517 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
526 test_expect_failure () {
527 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
529 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
533 say >&3 "checking known breakage: $2"
534 if test_run_ "$2" expecting_failure
536 test_known_broken_ok_ "$1"
538 test_known_broken_failure_ "$1"
544 test_expect_success () {
545 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
547 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
551 say >&3 "expecting success: $2"
562 # test_external runs external test scripts that provide continuous
563 # test output about their progress, and succeeds/fails on
564 # zero/non-zero exit code. It outputs the test output on stdout even
565 # in non-verbose mode, and announces the external script with "# run
566 # <n>: ..." before running it. When providing relative paths, keep in
567 # mind that all scripts run in "trash directory".
568 # Usage: test_external description command arguments...
569 # Example: test_external 'Perl API' perl ../path/to/test.pl
571 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
573 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
577 if ! test_skip "$descr" "$@"
579 # Announce the script to reduce confusion about the
580 # test output that follows.
581 say_color "" "# run $test_count: $descr ($*)"
582 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
583 # to be able to use them in script
584 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
585 # Run command; redirect its stderr to &4 as in
586 # test_run_, but keep its stdout on our stdout even in
591 if test $test_external_has_tap -eq 0; then
594 say_color "" "# test_external test $descr was ok"
595 test_success=$(($test_success + 1))
598 if test $test_external_has_tap -eq 0; then
599 test_failure_ "$descr" "$@"
601 say_color error "# test_external test $descr failed: $@"
602 test_failure=$(($test_failure + 1))
608 # Like test_external, but in addition tests that the command generated
609 # no output on stderr.
610 test_external_without_stderr () {
611 # The temporary file has no (and must have no) security
614 stderr="$tmp/git-external-stderr.$$.tmp"
615 test_external "$@" 4> "$stderr"
616 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
617 descr="no stderr: $1"
619 say >&3 "# expecting no stderr from previous command"
620 if [ ! -s "$stderr" ]; then
623 if test $test_external_has_tap -eq 0; then
626 say_color "" "# test_external_without_stderr test $descr was ok"
627 test_success=$(($test_success + 1))
630 if [ "$verbose" = t ]; then
631 output=`echo; echo "# Stderr is:"; cat "$stderr"`
635 # rm first in case test_failure exits.
637 if test $test_external_has_tap -eq 0; then
638 test_failure_ "$descr" "$@" "$output"
640 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
641 test_failure=$(($test_failure + 1))
646 # debugging-friendly alternatives to "test [-f|-d|-e]"
647 # The commands test the existence or non-existence of $1. $2 can be
648 # given to provide a more precise diagnosis.
649 test_path_is_file () {
652 echo "File $1 doesn't exist. $*"
657 test_path_is_dir () {
660 echo "Directory $1 doesn't exist. $*"
665 test_path_is_missing () {
670 if [ $# -ge 1 ]; then
677 # test_line_count checks that a file has the number of lines it
678 # ought to. For example:
680 # test_expect_success 'produce exactly one line of output' '
681 # do something >output &&
682 # test_line_count = 1 output
685 # is like "test $(wc -l <output) = 1" except that it passes the
686 # output through when the number of lines is wrong.
691 error "bug in the test script: not 3 parameters to test_line_count"
692 elif ! test $(wc -l <"$3") "$1" "$2"
694 echo "test_line_count: line count for $3 !$1 $2"
700 # This is not among top-level (test_expect_success | test_expect_failure)
701 # but is a prefix that can be used in the test script, like:
703 # test_expect_success 'complain and die' '
705 # do something else &&
706 # test_must_fail git checkout ../outerspace
709 # Writing this as "! git checkout ../outerspace" is wrong, because
710 # the failure could be due to a segv. We want a controlled failure.
715 if test $exit_code = 0; then
716 echo >&2 "test_must_fail: command succeeded: $*"
718 elif test $exit_code -gt 129 -a $exit_code -le 192; then
719 echo >&2 "test_must_fail: died by signal: $*"
721 elif test $exit_code = 127; then
722 echo >&2 "test_must_fail: command not found: $*"
728 # Similar to test_must_fail, but tolerates success, too. This is
729 # meant to be used in contexts like:
731 # test_expect_success 'some command works without configuration' '
732 # test_might_fail git config --unset all.configuration &&
736 # Writing "git config --unset all.configuration || :" would be wrong,
737 # because we want to notice if it fails due to segv.
742 if test $exit_code -gt 129 -a $exit_code -le 192; then
743 echo >&2 "test_might_fail: died by signal: $*"
745 elif test $exit_code = 127; then
746 echo >&2 "test_might_fail: command not found: $*"
752 # Similar to test_must_fail and test_might_fail, but check that a
753 # given command exited with a given exit code. Meant to be used as:
755 # test_expect_success 'Merge with d/f conflicts' '
756 # test_expect_code 1 git merge "merge msg" B master
759 test_expect_code () {
764 if test $exit_code = $want_code
769 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
773 # test_cmp is a helper function to compare actual and expected output.
774 # You can use it like:
776 # test_expect_success 'foo works' '
777 # echo expected >expected &&
779 # test_cmp expected actual
782 # This could be written as either "cmp" or "diff -u", but:
783 # - cmp's output is not nearly as easy to read as diff -u
784 # - not all diff versions understand "-u"
790 # This function can be used to schedule some commands to be run
791 # unconditionally at the end of the test to restore sanity:
793 # test_expect_success 'test core.capslock' '
794 # git config core.capslock true &&
795 # test_when_finished "git config --unset core.capslock" &&
799 # That would be roughly equivalent to
801 # test_expect_success 'test core.capslock' '
802 # git config core.capslock true &&
804 # git config --unset core.capslock
807 # except that the greeting and config --unset must both succeed for
810 # Note that under --immediate mode, no clean-up is done to help diagnose
813 test_when_finished () {
815 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
818 # Most tests can use the created repository, but some may need to create more.
819 # Usage: test_create_repo <directory>
820 test_create_repo () {
822 error "bug in the test script: not 1 parameter to test-create-repo"
826 cd "$repo" || error "Cannot setup test environment"
827 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
828 error "cannot run git init -- have you built things yet?"
829 mv .git/hooks .git/hooks-disabled
836 if test -z "$HARNESS_ACTIVE"; then
837 test_results_dir="$TEST_DIRECTORY/test-results"
838 mkdir -p "$test_results_dir"
839 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
841 cat >>"$test_results_path" <<-EOF
843 success $test_success
851 if test "$test_fixed" != 0
853 say_color pass "# fixed $test_fixed known breakage(s)"
855 if test "$test_broken" != 0
857 say_color error "# still have $test_broken known breakage(s)"
858 msg="remaining $(($test_count-$test_broken)) test(s)"
860 msg="$test_count test(s)"
862 case "$test_failure" in
864 # Maybe print SKIP message
865 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
867 if test $test_external_has_tap -eq 0; then
868 say_color pass "# passed all $msg"
869 say "1..$test_count$skip_all"
872 test -d "$remove_trash" &&
873 cd "$(dirname "$remove_trash")" &&
874 rm -rf "$(basename "$remove_trash")"
879 if test $test_external_has_tap -eq 0; then
880 say_color error "# failed $test_failure among $msg"
889 # Test the binaries we have just built. The tests are kept in
890 # t/ subdirectory and are run in 'trash directory' subdirectory.
891 if test -z "$TEST_DIRECTORY"
893 # We allow tests to override this, in case they want to run tests
894 # outside of t/, e.g. for running tests on the test library
896 TEST_DIRECTORY=$(pwd)
898 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
900 if test -n "$valgrind"
904 test "$1" = "$(readlink "$2")" || {
912 while test -d "$2".lock
914 say "Waiting for lock on $2."
921 make_valgrind_symlink () {
922 # handle only executables, unless they are shell libraries that
923 # need to be in the exec-path. We will just use "#!" as a
924 # guess for a shell-script, since we have no idea what the user
925 # may have configured as the shell path.
927 test "#!" = "$(head -c 2 <"$1")" ||
930 base=$(basename "$1")
931 symlink_target=$GIT_BUILD_DIR/$base
932 # do not override scripts
933 if test -x "$symlink_target" &&
934 test ! -d "$symlink_target" &&
935 test "#!" != "$(head -c 2 < "$symlink_target")"
937 symlink_target=../valgrind.sh
941 symlink_target=../unprocessed-script
943 # create the link, or replace it if it is out of date
944 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
947 # override all git executables in TEST_DIRECTORY/..
948 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
949 mkdir -p "$GIT_VALGRIND"/bin
950 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
952 make_valgrind_symlink $file
954 # special-case the mergetools loadables
955 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
960 ls "$path"/git-* 2> /dev/null |
963 make_valgrind_symlink "$file"
967 PATH=$GIT_VALGRIND/bin:$PATH
968 GIT_EXEC_PATH=$GIT_VALGRIND/bin
970 elif test -n "$GIT_TEST_INSTALLED" ; then
971 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
972 error "Cannot run git from $GIT_TEST_INSTALLED."
973 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
974 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
975 else # normal case, use ../bin-wrappers only unless $with_dashes:
976 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
977 if ! test -x "$git_bin_dir/git" ; then
978 if test -z "$with_dashes" ; then
979 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
983 PATH="$git_bin_dir:$PATH"
984 GIT_EXEC_PATH=$GIT_BUILD_DIR
985 if test -n "$with_dashes" ; then
986 PATH="$GIT_BUILD_DIR:$PATH"
989 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
991 GIT_CONFIG_NOSYSTEM=1
993 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
995 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
997 if test -z "$GIT_TEST_CMP"
999 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1001 GIT_TEST_CMP="$DIFF -c"
1003 GIT_TEST_CMP="$DIFF -u"
1007 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1009 test -d "$GIT_BUILD_DIR"/templates/blt || {
1010 error "You haven't built things yet, have you?"
1013 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1015 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1017 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1018 error "You haven't built git_remote_helpers yet, have you?"
1022 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1023 echo >&2 'You need to build test-chmtime:'
1024 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1029 test="trash directory.$(basename "$0" .sh)"
1030 test -n "$root" && test="$root/$test"
1032 /*) TRASH_DIRECTORY="$test" ;;
1033 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1035 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1038 echo >&5 "FATAL: Cannot prepare test area"
1042 HOME="$TRASH_DIRECTORY"
1045 test_create_repo "$test"
1046 # Use -P to resolve symlinks in our working directory so that the cwd
1047 # in subprocesses like git equals our $PWD (for pathname comparisons).
1048 cd -P "$test" || exit 1
1051 this_test=${this_test%%-*}
1052 for skp in $GIT_SKIP_TESTS
1054 case "$this_test" in
1056 say_color skip >&3 "skipping test $this_test altogether"
1057 skip_all="skip all tests in $this_test"
1062 # Provide an implementation of the 'yes' utility
1077 # Fix some commands on Windows
1080 # Windows has its own (incompatible) sort and find
1090 # git sees Windows-style pwd
1094 # no POSIX permissions
1095 # backslashes in pathspec are converted to '/'
1096 # exec does not inherit the PID
1097 test_set_prereq MINGW
1098 test_set_prereq SED_STRIPS_CR
1101 test_set_prereq POSIXPERM
1102 test_set_prereq EXECKEEPSPID
1103 test_set_prereq NOT_MINGW
1104 test_set_prereq SED_STRIPS_CR
1107 test_set_prereq POSIXPERM
1108 test_set_prereq BSLASHPSPEC
1109 test_set_prereq EXECKEEPSPID
1110 test_set_prereq NOT_MINGW
1114 test -z "$NO_PERL" && test_set_prereq PERL
1115 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1116 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1118 # Can we rely on git's output in the C locale?
1119 if test -n "$GETTEXT_POISON"
1121 GIT_GETTEXT_POISON=YesPlease
1122 export GIT_GETTEXT_POISON
1124 test_set_prereq C_LOCALE_OUTPUT
1127 # Use this instead of test_cmp to compare files that contain expected and
1128 # actual output from git commands that can be translated. When running
1129 # under GETTEXT_POISON this pretends that the command produced expected
1132 test -n "$GETTEXT_POISON" || test_cmp "$@"
1135 # Use this instead of "grep expected-string actual" to see if the
1136 # output from a git command that can be translated either contains an
1137 # expected string, or does not contain an unwanted one. When running
1138 # under GETTEXT_POISON this pretends that the command produced expected
1141 if test -n "$GETTEXT_POISON"
1144 elif test "x!" = "x$1"
1153 # test whether the filesystem supports symbolic links
1154 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1157 # When the tests are run as root, permission tests will report that
1158 # things are writable when they shouldn't be.
1159 test -w / || test_set_prereq SANITY